#include "quicksort.h"


void Permuter(CvPoint2D32f *t,int i,int j)
{
	CvPoint2D32f temp;
	temp = t[i];
	t[i] = t[j];
	t[j] = temp;
}  
/*! Tri rapide dans la ligne
	\arg t : Liste d'lment
	\arg p : borne min de recherche de tri
	\arg r : borne max de recherche de tri
*/

int Partition (CvPoint2D32f *t,int p,int r)
{
	int i,j;
	int z;
	CvPoint2D32f x;
	z=p+rand()%(r-p);
	x.y=t[z].y;
	i=p-1;
	j=r+1;
	do
	{
		do 
			i++;
		while( t[i].y < x.y );
		do
			j--;
		while( t[j].y > x.y );
		if (i<j) 
			Permuter(t,i,j);
	}
	while(i<j);
	return j;
}
/*! Tri rapide d'lment
	\arg t : Liste d'lment
	\arg p : borne min de recherche de tri
	\arg r : borne max de recherche de tri
*/
void quicksort(CvPoint2D32f *t,int p,int r)
{
	int q;
	if (p!=r)
	{
		q=Partition(t,p,r);
		quicksort(t,p,q);
		quicksort(t,q+1,r);
	}
}